
open Sdl;;
open Mixer;;
open Event;;
open Format;;

let string_of_flag = function
  | TIMER -> "TIMER "
  | AUDIO -> "AUDIO"
  | VIDEO -> "VIDEO"
  | CDROM -> "CDROM"
  | JOYSTICK -> "JOYSTICK"
  | NOPARACHUTE -> "NOPARACHUTE"       
  | EVENTTHREAD -> "EVENTTHREAD"
  | EVERYTHING ->  "EVERYTHING"
;;


 
let clean_up m =
  printf "Exiting...@?"; 
  Mixer.fade_out_music(1000);
  Mixer.free_music m;
  Mixer.close_audio();
  Sdl.quit();
  printf "done@.";
;;

let test music_file = 
  Sdl.init [AUDIO];
  printf "trying to open mixer...@?"; 
  try
    Mixer.open_audio 11025 Mixer.format_AUDIO_U8 1 512;
    printf "ok@.";
    let m = Mixer.load_music music_file in
    let _ = Mixer.play_music m (-1) in      
      begin
	try
	  Sys.catch_break true;
	  printf "press Enter to stop playing music@.";
	  let _ = read_line() in ()
	with
	    Sys.Break -> ();
      end;
      clean_up m
  with
      Mix_failure msg -> 
	begin
	  printf "failed (%s)@." msg;
	  exit 1;
	end;
	
;;

if Array.length Sys.argv != 2
then
    printf "Usage: test_mixer <sound file>@."
else
  begin
    Printexc.catch test Sys.argv.(1);
    printf "Program exited normally.@.";
  end
;;
    

